function [C, Cn] = FormBoxBump(a,b,c)
 
% Constructs 24 boxes with a bump
% The contours are organised as the complex rows of C
% The contour is described by res+1 points, 
%   where the first and last are identical

j = sqrt(-1);
res = 25;
s = 24;
C = zeros(s, res+1);
Cn = zeros(1, s);
rand('state',0)

for ss = 1:s
    us = 2*rand(1,3) - 1;
%     if ss==1
%         us(3) = 0;
%     end
    hor = 4 + us(1) * a;
    ver = 1 + us(2) * b;
    cen = 2 + us(3) * c;
    
    C(ss,1) = hor + j * ver;   
    C(ss,2) = hor;   
    C(ss,3) = hor * 2/3;   
    C(ss,4) = hor * 1/3;   
    C(ss,5) = 0;   
    C(ss,6) = j * ver;  
    for i = 1:19
        angle = pi * (19 - i) / 18;
        C(ss,6+i) = cen + j * ver + 0.5 * exp(j*angle);
    end
    C(ss, res+1) = C(ss,1);
    Cn(ss) = res+1;
end


