function ShowExtremes(C, Cn, Ccum, A, P, ends, curvSmear, curvSkip, mu)
% Displays the contours of the examples with marks at the extreme curvature
% correpsondences. These extremes are defined on the mean shape
% Updated September 2004 to cope with closed contours
% (The previous version was used only for silhuettes)

closed = (ends==1);
threshold = 1.5;
muCurv = Curvatures(mu, curvSmear, ends, curvSkip);
% figure(42); plot(muCurv,'-+');

% for closed curves we have mean(muCurv approx 1, remove this bias:
if closed muCurv = muCurv - 1; end;

lenCurv = length(muCurv);
if closed  
    N = P;   
else
    N = P + 1;   % open curves have one extra mark
end

%--- old code: 
% ac = abs(muCurv);
% acp = ac(3:end);
% acm = ac(1:end-2);
% acc = ac(2:end-1);
% pps = acc>0.5 & acm<acc & acp<acc;
% pp = curvSkip+2 : N-curvSkip-1;
% pp = pp(pps);
% 
% ac = muCurv;
% acp = ac(3:end);
% acm = ac(1:end-2);
% acc = ac(2:end-1);
% dpp = 0.5 * (acm(pps) - acp(pps))./(acm(pps) + acp(pps) - 2*acc(pps));

%--- It is sufficient to look for local maxima in abs(curvature) 
%   especially since closed curve curvatures have been subtracted 1

ac = abs(muCurv);

% support closed curves - doesn't hurt open curves
acp = [ac(2:end) ac(1)];
acm = [ac(end) ac(1:end-1)];

%-- Pick local maxima in excess of 0.5
pps = ac>threshold & acm<ac & acp<ac;

if closed
    pp = 1 : N;
    pp = pp(pps);
else
  % open curves are tricky since here the curvature is not defined in the curvSkip marks
  % in each end
    pp = curvSkip+1 : N-curvSkip;
    pp = pp(pps);
end

ac = muCurv;
acp = [ac(2:end) ac(1)];
acm = [ac(end) ac(1:end-1)];
dpp = 0.5 * (acm(pps) - acp(pps))./(acm(pps) + acp(pps) - 2*ac(pps));

s = size(C, 1);
for ss=1:s
    X(ss,:) = FormShape(C(ss,1:Cn(ss)), Ccum(ss,1:Cn(ss)), ...
        A(ss,:), P, ends);
end

pp2 = pp + sign(dpp);
for i=1:length(pp2)
    pp2(i) = mod(pp2(i)-1, N) + 1;
end

XX = repmat((1-abs(dpp)), s, 1) .* X(:,pp) ...
   + repmat(   abs(dpp) , s, 1) .* X(:,pp2); 
%.. not 100% accurate - shoould use FormShpae instead!!
XXsize = size(XX,2)
h = figure(8);
clf
nc = 11;
nr = 2;
if s==24 
    nc=8;
    nr=3;
    nc=4;
    nr=6;
end
for ss = 1:s,
    c_y = fix((ss-1)/nc);
    c_x = ss - c_y*nc;
    js_subplot((c_x-1)/nc, ((nr-1)-c_y)/nr, 1/(nc+3), 1/(nr+0.2)); 
    hold on
    plot(C(ss,:)','b');
%     plot(X(ss,pp)','r.');
%     plot(X(ss,pp(1:4:end))','k.');
%     plot(X(ss,pp(2:4:end))','g.');
%     plot(X(ss,pp(3:4:end))','y.');
    plot(XX(ss,:)','r.');
    plot(XX(ss,1:4:end)','k.');
if XXsize>1,   plot(XX(ss,2:4:end)','g.');, end
 %   plot(XX(ss,3:4:end)','y.');
%     if s~=24 plot(X(ss,[1 end])','b.'); end;
    if ~closed, plot(X(ss,[1 end])','b.'), end 
    axis ij
    axis equal
    axis off
%     title(int2str(ss))
end
hold off;

% print('-depsc','extremes.eps');
% print -depsc -tiff -r300 picture1:
% exportfig(h, 'ponycol', 'format', 'psc2');
